#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;
using ll = long long;
const long double ld = (long double)(1);

ll calc1(ll a, ll b, ll c) {
	auto d = [](ll a, ll b) {
		if (a < b)
			swap(a, b);
		return (a - b + 1) / 2;
	};
	ll first = a + c - a % c;
	ll last = b - b % c;
	ll ctr = d(1, c - 1) + 1;
	ll mid = ctr * max(0ll, (last - first) / c);
	ll asw = d(a, first - 1) + 1 + mid + d(last + 1, b);
	if (first > last)
		asw = d(a, b);
	return asw;
} 
/*
ll calc2(ll a, ll b, ll c) {
	ll mid_c = floor(1.0 * b / c) - ceil(1.0 * a / c);
	ll start = floor((ceil(1.0 * a / c) * c - a) / 2) + 1;
	ll end = ceil((b - floor(1.0 * b / c) * c - 1) / 2);
	ll asw2 = mid_c * ceil(1.0 * c / 2) + start + end;
	return asw2;
}
*/

int main() {
	ll a, b, c;
	cin >> a >> b >> c;

	/*
	calc1(11, 12, 7);
	for (;;) {
		ll a = rand() % 16, b = rand() % 16, c = rand() % 16;
		if (a > b)
			swap(a, b);
		if (a == b || c == 0 || (a % c == 0) || (b % c == 0))
			continue;
		ll asw1 = calc1(a, b, c), asw2 = calc2(a, b, c);
		if (asw1 != asw2)
			system("pause>nul");
	}
	*/
	cout << calc1(a, b, c) << endl;
	//system("pause>nul");
	return 0;
}

