#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

ll more(ll n, ll last, bool less) {
	ll asw = 0;
	if (n < 0)
		return 0;
	if (n == 0)
		return 1;
	if (less)
		for (ll i = 1; i < last; ++i)
			asw += more(n - i, i, !less);
	else
		for (int i = last + 1; i <= n; ++i)
			asw += more(n - i, i, !less);
	return asw % MOD;
}

int main() {
	int n, k;
	cin >> n >> k;
	
	ll asw = more(n - k, k, false) + more(n - k, k, true) - (n == k);
	cout << asw << endl;
	//system("pause>nul");
	return 0;
}