#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

map<pair<ll, ll>, ll> m;

ll more(ll n, ll last, bool less) {
	ll asw = 0;
	if (n < 0)
		return 0;
	if (n == 0)
		return 1;
	pair<ll, ll> ukey = { n, last * (less ? 1 : -1) };
	if (less)
		for (register int i = 1; i < last; ++i) {
			pair<ll, ll> key = { n - i, i * (!less ? 1 : -1) };
			if (m.find(key) != m.end())
				asw += m[key];
			else
				asw += more(n - i, i, !less);
		}
	else
		for (register int i = last + 1; i <= n; ++i) {
			pair<ll, ll> key = { n - i, i * (!less ? 1 : -1) };
			if (m.find(key) != m.end())
				asw += m[key];
			else
				asw += more(n - i, i, !less);
		}
	asw %= MOD;
	m[ukey] = asw;
	return asw;
}

int main() {
	int n, k;
	cin >> n >> k;

	ll asw = more(n - k, k, false) + more(n - k, k, true) - (n == k);
	cout << asw << endl;
	//system("pause>nul");
	return 0;
}