#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

map<ll, map<ll, ll>> gg;

ll more(ll n, ll bord, bool less) {
	if (n < 0)
		return 0;
	if (n == 0)
		return 1;
	ll key = n * (less ? -1 : 1);
	ll asw = 0;
	bool stupid = false;

	if (gg.find(key) != gg.end()) {
		auto &res = gg[key];
		auto gut = res.upper_bound(bord);
		if (gut != res.end()) {
			stupid = true;
			asw = gut->second;
			ll delta = gut->first;

			if (less) {
				//asw = 0;
				for (int i = bord; i < delta; ++i)
					asw -= more(n - i, i, !less);
				//for (int i = delta; i < bord; ++i)
				//	asw += more(n - i, i, !less);
			}
			else {
				asw = 0;
				for (int i = bord + 1; i <= n; ++i)
					asw += more(n - i, i, !less);
				//for (int i = delta + 1; i <= bord; ++i)
				//	asw -= more(n - i, i, !less);
			}
		}
	} 

	if (!stupid) {
		if (less) {
			for (int i = 1; i < bord; ++i)
				asw += more(n - i, i, !less);
		}
		else {
			for (int i = bord + 1; i <= n; ++i)
				asw += more(n - i, i, !less);
		}
	}

	asw %= MOD;
	//cout << key << " " << bord << " " << asw << endl;
	gg[key][bord] = asw;
	return asw;
}

int main() {
	int n, k;
	cin >> n >> k;

	ll asw = more(n - k, k, false) + more(n - k, k, true) - (n == k);
	cout << asw << endl;
	//system("pause>nul");
	return 0;
}
