#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

map<ll, map<ll ,ll>> gg;

ll more(ll n, ll last, bool less) {
	if (n == 0)
		return 1;

	ll key = last * (less ? -1 : 1);
	ll ready = 0, asw = 0;
	if (gg.find(key) != gg.end()) {
		auto &mp = gg[key];
		auto res = mp.lower_bound(n);
		if (res != mp.end()) {
			ready = res->first;
			asw = res->second;
		}
	}

	if (less)
		for (ll i = ready + 1; i < last; ++i)
			asw += more(n - i, i, !less);
	else
		for (ll i = max(ready, last) + 1; i <= n; ++i)
			asw += more(n - i, i, !less);
	asw %= MOD;
	gg[key][n] = asw;
	return asw % MOD;
}

int main() {
	int n, k;
	cin >> n >> k;
	
	ll asw = more(n - k, k, false) + more(n - k, k, true) - (n == k);
	cout << asw << endl;
	//system("pause>nul");
	return 0;
}