#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

map<ll, map<ll, ll>> gg;

ll more(ll n, ll used, bool less) {
	if (n < 0)
		return 0;
	if (n == 0)
		return 1;

	ll key = n * (n ? -1 : 1);
	ll ready = -1, asw = 0;
	if (gg.find(key) != gg.end()) {
		auto &mp = gg[key];
		auto res = mp.lower_bound(used);
		if (res != mp.end()) {
			ready = res->first;
			asw = res->second;
		}
	}

	if (ready == -1) {
		if (less)
			for (ll i = 1; i < used; ++i)
				asw += more(n - i, i, !less);
		else
			for (int i = used + 1; i <= n; ++i)
				asw += more(n - i, i, !less);
	}
	else {
		if (less)
			for (ll i = ready; i < used; ++i)
				asw += more(n - i, i, !less);
		else
			for (ll i = ready + 1; i <= used; ++i)
				asw -= more(n - i, i, !less);
	}

	asw %= MOD;
	gg[key][used] = asw;
	//cout << "res ost = " << n << " last = " << used << " = " << asw << endl;
	return asw;
}

int main() {
	int n, k;
	cin >> n >> k;

	ll asw = more(n - k, k, false) + more(n - k, k, true) - (n == k);
	cout << asw << endl;
	//system("pause>nul");
	return 0;
}